
function [f, g, nfunc, ngrad] = evalfg (n, x, nfunc0, ngrad0)

nfunc = nfunc0 +1;
ngrad = ngrad0 + 1;

g = zeros(n,1);

% provide the function and gradient values here

T = x(1) - 1.0;
g(1) = 0.5*T;
f = g(1)^2;
     
for i=1:(n-1)

    T = x(i+1)^2 - 2*x(i) + 1 ;
    g(i) = g(i) - 4.0 * T;
    g(i+1) = g(i+1) + 4.0 * T * x(i+1);
    f = f + T^2;
    
end



