
function [g, ngrad] = evalg (n, x, ngrad0)
    
ngrad = ngrad0 + 1;

g = zeros(n,1);

% provide the gradient value here
     
g(1) = 2.0 * ( 0.5 * ( x(1) - 1.0 ) ) * 0.5;

for i=1:(n-1)

    T = x(i+1) * x(i+1) - 2.0 * x(i) + 1.0;
    g(i) = g(i) - 4.0 * T;
    g(i+1) = g(i+1) + 4.0 * T * x(i+1);

end


